//
// TourSearchObject.h
// IvyMedia
//
// Created by haibara on 9/3/14.
//
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>

@interface TourSearchData : NSObject

@property (nonatomic, assign) NSInteger pid;
@property (nonatomic, assign) BOOL is_room_based;
@property (nonatomic, strong) NSString *tour_code;
@property (nonatomic, strong) NSString *product_name;
@property (nonatomic, assign) NSInteger days;
@property (nonatomic, assign) NSInteger days_from;
@property (nonatomic, strong) NSString *image_url;
@property (nonatomic, strong) NSString *currency_code;
@property (nonatomic, strong) NSString *currency_symbol;
@property (nonatomic, strong) NSString *lowest_price;
@property (nonatomic, strong) NSString *list_price;
@property (nonatomic, strong) NSString *save_price;
@property (nonatomic, assign) CGFloat star_rating;
@property (nonatomic, assign) NSInteger review_total;
@property (nonatomic, assign) NSInteger promotion_type;
@property (nonatomic, assign) CGFloat room_discount_percent;
@property (nonatomic, strong) NSString *early_booking;
@property (nonatomic, strong) NSString *end_date;
@property (nonatomic, assign) BOOL is_today_deal;
@property (nonatomic, strong) NSString *operates_on;
@property (nonatomic, strong) NSString *duration;
@property (nonatomic, strong) NSString *departs_from;
@property (nonatomic, strong) NSArray *date_options;

@property (nonatomic, strong, readonly) NSString *promotionText;
@property (nonatomic, strong, readonly) NSArray *promotions;

- (NSString *)adaptiveImageUrlByWidth:(CGFloat)width;
- (NSAttributedString *)attributedPriceTextWithFont:(UIFont *)font;
- (NSAttributedString *)attributedReviewTextWithFont:(UIFont *)font highlighted:(BOOL)highlighted;

@end
